/* tracker-view.c generated by valac 0.13.4.8-6faa4, the Vala compiler
 * generated from tracker-view.vala, do not modify */

/**/
/* Copyright 2010, Martyn Russell <martyn@lanedo.com>*/
/**/
/* This program is free software; you can redistribute it and/or*/
/* modify it under the terms of the GNU General Public License*/
/* as published by the Free Software Foundation; either version 2*/
/* of the License, or (at your option) any later version.*/
/**/
/* This program is distributed in the hope that it will be useful,*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/* GNU General Public License for more details.*/
/**/
/* You should have received a copy of the GNU General Public License*/
/* along with this program; if not, write to the Free Software*/
/* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA*/
/* 02110-1301, USA.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>


#define TRACKER_TYPE_VIEW (tracker_view_get_type ())
#define TRACKER_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TRACKER_TYPE_VIEW, TrackerView))
#define TRACKER_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TRACKER_TYPE_VIEW, TrackerViewClass))
#define TRACKER_IS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TRACKER_TYPE_VIEW))
#define TRACKER_IS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TRACKER_TYPE_VIEW))
#define TRACKER_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TRACKER_TYPE_VIEW, TrackerViewClass))

typedef struct _TrackerView TrackerView;
typedef struct _TrackerViewClass TrackerViewClass;
typedef struct _TrackerViewPrivate TrackerViewPrivate;

#define TRACKER_VIEW_TYPE_DISPLAY (tracker_view_display_get_type ())

#define TRACKER_TYPE_RESULT_STORE (tracker_result_store_get_type ())
#define TRACKER_RESULT_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TRACKER_TYPE_RESULT_STORE, TrackerResultStore))
#define TRACKER_RESULT_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TRACKER_TYPE_RESULT_STORE, TrackerResultStoreClass))
#define TRACKER_IS_RESULT_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TRACKER_TYPE_RESULT_STORE))
#define TRACKER_IS_RESULT_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TRACKER_TYPE_RESULT_STORE))
#define TRACKER_RESULT_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TRACKER_TYPE_RESULT_STORE, TrackerResultStoreClass))

typedef struct _TrackerResultStore TrackerResultStore;
typedef struct _TrackerResultStoreClass TrackerResultStoreClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))

#define TRACKER_QUERY_TYPE_TYPE (tracker_query_type_get_type ())

struct _TrackerView {
	GtkScrolledWindow parent_instance;
	TrackerViewPrivate * priv;
};

struct _TrackerViewClass {
	GtkScrolledWindowClass parent_class;
};

typedef enum  {
	TRACKER_VIEW_DISPLAY_NO_RESULTS,
	TRACKER_VIEW_DISPLAY_CATEGORIES,
	TRACKER_VIEW_DISPLAY_FILE_LIST,
	TRACKER_VIEW_DISPLAY_FILE_ICONS
} TrackerViewDisplay;

struct _TrackerViewPrivate {
	TrackerViewDisplay _display;
	TrackerResultStore* _store;
	GtkWidget* view;
};

typedef enum  {
	TRACKER_QUERY_TYPE_ALL,
	TRACKER_QUERY_TYPE_CONTACTS,
	TRACKER_QUERY_TYPE_APPLICATIONS,
	TRACKER_QUERY_TYPE_MUSIC,
	TRACKER_QUERY_TYPE_IMAGES,
	TRACKER_QUERY_TYPE_VIDEOS,
	TRACKER_QUERY_TYPE_DOCUMENTS,
	TRACKER_QUERY_TYPE_MAIL,
	TRACKER_QUERY_TYPE_CALENDAR,
	TRACKER_QUERY_TYPE_FOLDERS,
	TRACKER_QUERY_TYPE_BOOKMARKS
} TrackerQueryType;


static gpointer tracker_view_parent_class = NULL;

GType tracker_view_get_type (void) G_GNUC_CONST;
GType tracker_view_display_get_type (void) G_GNUC_CONST;
GType tracker_result_store_get_type (void) G_GNUC_CONST;
#define TRACKER_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TRACKER_TYPE_VIEW, TrackerViewPrivate))
enum  {
	TRACKER_VIEW_DUMMY_PROPERTY,
	TRACKER_VIEW_DISPLAY,
	TRACKER_VIEW_STORE
};
static void tracker_view_store_row_changed (TrackerView* self, GtkTreeModel* model, GtkTreePath* path, GtkTreeIter* iter);
static gboolean tracker_view_row_selection_func (TrackerView* self, GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_selected);
static void tracker_view_real_unmap (GtkWidget* base);
TrackerResultStore* tracker_view_get_store (TrackerView* self);
void tracker_result_store_cancel_search (TrackerResultStore* self);
TrackerView* tracker_view_new (TrackerViewDisplay* _display, TrackerResultStore* store);
TrackerView* tracker_view_construct (GType object_type, TrackerViewDisplay* _display, TrackerResultStore* store);
static void tracker_view_set_display (TrackerView* self, TrackerViewDisplay value);
static void _tracker_view_store_row_changed_gtk_tree_model_row_changed (GtkTreeModel* _sender, GtkTreePath* path, GtkTreeIter* iter, gpointer self);
TrackerViewDisplay tracker_view_get_display (TrackerView* self);
static void tracker_view_setup_model (TrackerView* self);
static void tracker_view_renderer_background_func (TrackerView* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter);
static void _tracker_view_renderer_background_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static void tracker_view_text_renderer_func (TrackerView* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter);
static void _tracker_view_text_renderer_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static void tracker_view_file_date_renderer_func (TrackerView* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter);
static void _tracker_view_file_date_renderer_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static void tracker_view_file_size_renderer_func (TrackerView* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter);
static void _tracker_view_file_size_renderer_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static gboolean _tracker_view_row_selection_func_gtk_tree_selection_func (GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected, gpointer self);
static void tracker_view_category_detail_renderer_func (TrackerView* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter);
static void _tracker_view_category_detail_renderer_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
GType tracker_query_type_get_type (void) G_GNUC_CONST;
gchar* tracker_time_format_from_iso8601 (const gchar* s);
gchar* tracker_time_format_from_seconds (const gchar* seconds_str);
void tracker_view_set_store (TrackerView* self, TrackerResultStore* value);
static void tracker_view_finalize (GObject* obj);
static void _vala_tracker_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_tracker_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType tracker_view_display_get_type (void) {
	static volatile gsize tracker_view_display_type_id__volatile = 0;
	if (g_once_init_enter (&tracker_view_display_type_id__volatile)) {
		static const GEnumValue values[] = {{TRACKER_VIEW_DISPLAY_NO_RESULTS, "TRACKER_VIEW_DISPLAY_NO_RESULTS", "no-results"}, {TRACKER_VIEW_DISPLAY_CATEGORIES, "TRACKER_VIEW_DISPLAY_CATEGORIES", "categories"}, {TRACKER_VIEW_DISPLAY_FILE_LIST, "TRACKER_VIEW_DISPLAY_FILE_LIST", "file-list"}, {TRACKER_VIEW_DISPLAY_FILE_ICONS, "TRACKER_VIEW_DISPLAY_FILE_ICONS", "file-icons"}, {0, NULL, NULL}};
		GType tracker_view_display_type_id;
		tracker_view_display_type_id = g_enum_register_static ("TrackerViewDisplay", values);
		g_once_init_leave (&tracker_view_display_type_id__volatile, tracker_view_display_type_id);
	}
	return tracker_view_display_type_id__volatile;
}


static void tracker_view_store_row_changed (TrackerView* self, GtkTreeModel* model, GtkTreePath* path, GtkTreeIter* iter) {
	GtkTreeModel* _tmp0_;
	GtkTreeIter _tmp1_;
	gint _tmp2_ = 0;
	gint n_children;
	gint _tmp3_;
#line 62 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (self != NULL);
#line 62 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (model != NULL);
#line 62 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (path != NULL);
#line 62 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (iter != NULL);
#line 65 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = model;
#line 65 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp1_ = *iter;
#line 65 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp2_ = gtk_tree_model_iter_n_children (_tmp0_, &_tmp1_);
#line 65 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	n_children = _tmp2_;
#line 67 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp3_ = n_children;
#line 67 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp3_ > 0) {
#line 181 "tracker-view.c"
		GtkWidget* _tmp4_;
		GtkTreePath* _tmp5_;
#line 68 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp4_ = self->priv->view;
#line 68 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp5_ = path;
#line 68 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		gtk_tree_view_expand_row (GTK_TREE_VIEW (_tmp4_), _tmp5_, FALSE);
#line 190 "tracker-view.c"
	}
}


static gboolean tracker_view_row_selection_func (TrackerView* self, GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_selected) {
	gboolean result = FALSE;
	GtkTreePath* _tmp0_;
	gint _tmp1_ = 0;
#line 72 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 72 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_val_if_fail (selection != NULL, FALSE);
#line 72 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 72 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 76 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = path;
#line 76 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp1_ = gtk_tree_path_get_depth (_tmp0_);
#line 76 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp1_ == 1) {
#line 78 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		result = FALSE;
#line 78 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		return result;
#line 217 "tracker-view.c"
	}
#line 81 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	result = TRUE;
#line 81 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	return result;
#line 223 "tracker-view.c"
}


static void tracker_view_real_unmap (GtkWidget* base) {
	TrackerView * self;
	TrackerResultStore* _tmp0_;
	TrackerResultStore* _tmp1_;
#line 84 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	self = (TrackerView*) base;
#line 85 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = tracker_view_get_store (self);
#line 85 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp1_ = _tmp0_;
#line 85 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp1_ != NULL) {
#line 239 "tracker-view.c"
		TrackerResultStore* _tmp2_;
		TrackerResultStore* _tmp3_;
#line 86 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp2_ = tracker_view_get_store (self);
#line 86 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp3_ = _tmp2_;
#line 86 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		tracker_result_store_cancel_search (_tmp3_);
#line 248 "tracker-view.c"
	}
#line 89 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	GTK_WIDGET_CLASS (tracker_view_parent_class)->unmap ((GtkWidget*) GTK_SCROLLED_WINDOW (self));
#line 252 "tracker-view.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 98 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 259 "tracker-view.c"
}


static void _tracker_view_store_row_changed_gtk_tree_model_row_changed (GtkTreeModel* _sender, GtkTreePath* path, GtkTreeIter* iter, gpointer self) {
#line 99 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_store_row_changed (self, _sender, path, iter);
#line 266 "tracker-view.c"
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
#line 1414 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1415 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	result = self;
#line 1415 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	return result;
#line 278 "tracker-view.c"
}


TrackerView* tracker_view_construct (GType object_type, TrackerViewDisplay* _display, TrackerResultStore* store) {
	TrackerView * self = NULL;
	TrackerViewDisplay* _tmp0_;
	TrackerResultStore* _tmp1_;
	TrackerViewDisplay _tmp6_;
	TrackerViewDisplay _tmp23_;
#line 92 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	self = (TrackerView*) g_object_new (object_type, NULL);
#line 93 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
#line 95 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = _display;
#line 95 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_set_display (self, *_tmp0_);
#line 97 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp1_ = store;
#line 97 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp1_ != NULL) {
#line 300 "tracker-view.c"
		TrackerResultStore* _tmp2_;
		TrackerResultStore* _tmp3_;
		TrackerResultStore* _tmp4_;
		TrackerResultStore* _tmp5_;
#line 98 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp2_ = store;
#line 98 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 98 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_g_object_unref0 (self->priv->_store);
#line 98 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		self->priv->_store = _tmp3_;
#line 99 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp4_ = store;
#line 99 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_signal_connect_object ((GtkTreeModel*) _tmp4_, "row-changed", (GCallback) _tracker_view_store_row_changed_gtk_tree_model_row_changed, self, 0);
#line 100 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp5_ = store;
#line 100 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_debug ("tracker-view.vala:100: using store:%p", _tmp5_);
#line 321 "tracker-view.c"
	}
#line 103 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp6_ = self->priv->_display;
#line 103 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	switch (_tmp6_) {
#line 103 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_DISPLAY_NO_RESULTS:
#line 329 "tracker-view.c"
		{
			GtkLabel* l = NULL;
			GtkLabel* _tmp7_;
			GtkLabel* _tmp8_;
			const gchar* _tmp9_ = NULL;
			gchar* _tmp10_;
			gchar* message;
			const gchar* _tmp11_;
			const gchar* _tmp12_ = NULL;
			gchar* _tmp13_ = NULL;
			gchar* markup;
			GtkLabel* _tmp14_;
			GtkLabel* _tmp15_;
			const gchar* _tmp16_;
			GtkLabel* _tmp17_;
			GtkWidget* _tmp18_;
#line 107 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp7_ = (GtkLabel*) gtk_label_new ("");
#line 107 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp8_ = g_object_ref_sink (_tmp7_);
#line 107 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_object_unref0 (l);
#line 107 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			l = _tmp8_;
#line 109 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp9_ = _ ("No Search Results");
#line 109 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 109 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			message = _tmp10_;
#line 110 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp11_ = message;
#line 110 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp12_ = string_to_string (_tmp11_);
#line 110 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp13_ = g_strconcat ("<big>", _tmp12_, "</big>", NULL);
#line 110 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			markup = _tmp13_;
#line 112 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp14_ = l;
#line 112 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			gtk_label_set_use_markup (_tmp14_, TRUE);
#line 113 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp15_ = l;
#line 113 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp16_ = markup;
#line 113 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			gtk_label_set_markup (_tmp15_, _tmp16_);
#line 115 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp17_ = l;
#line 115 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp18_ = _g_object_ref0 ((GtkWidget*) _tmp17_);
#line 115 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_object_unref0 (self->priv->view);
#line 115 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			self->priv->view = _tmp18_;
#line 116 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_free0 (markup);
#line 116 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_free0 (message);
#line 116 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_object_unref0 (l);
#line 116 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			break;
#line 394 "tracker-view.c"
		}
#line 103 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_DISPLAY_CATEGORIES:
#line 103 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_DISPLAY_FILE_LIST:
#line 400 "tracker-view.c"
		{
			GtkTreeView* _tmp19_;
			GtkWidget* _tmp20_;
#line 120 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp19_ = (GtkTreeView*) gtk_tree_view_new ();
#line 120 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp20_ = (GtkWidget*) g_object_ref_sink (_tmp19_);
#line 120 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_object_unref0 (self->priv->view);
#line 120 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			self->priv->view = _tmp20_;
#line 121 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			break;
#line 414 "tracker-view.c"
		}
#line 103 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_DISPLAY_FILE_ICONS:
#line 418 "tracker-view.c"
		{
			GtkIconView* _tmp21_;
			GtkWidget* _tmp22_;
#line 124 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp21_ = (GtkIconView*) gtk_icon_view_new ();
#line 124 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp22_ = (GtkWidget*) g_object_ref_sink (_tmp21_);
#line 124 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_object_unref0 (self->priv->view);
#line 124 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			self->priv->view = _tmp22_;
#line 125 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			break;
#line 432 "tracker-view.c"
		}
		default:
#line 103 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		break;
#line 437 "tracker-view.c"
	}
#line 128 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp23_ = self->priv->_display;
#line 128 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp23_ == TRACKER_VIEW_DISPLAY_NO_RESULTS) {
#line 443 "tracker-view.c"
		GtkWidget* _tmp24_;
#line 129 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp24_ = self->priv->view;
#line 129 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		gtk_scrolled_window_add_with_viewport ((GtkScrolledWindow*) self, _tmp24_);
#line 449 "tracker-view.c"
	} else {
		GtkWidget* _tmp25_;
#line 131 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp25_ = self->priv->view;
#line 131 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		gtk_container_add ((GtkContainer*) self, _tmp25_);
#line 132 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		tracker_view_setup_model (self);
#line 458 "tracker-view.c"
	}
#line 135 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	GTK_WIDGET_CLASS (tracker_view_parent_class)->show_all ((GtkWidget*) GTK_SCROLLED_WINDOW (self));
#line 92 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	return self;
#line 464 "tracker-view.c"
}


TrackerView* tracker_view_new (TrackerViewDisplay* _display, TrackerResultStore* store) {
#line 92 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	return tracker_view_construct (TRACKER_TYPE_VIEW, _display, store);
#line 471 "tracker-view.c"
}


static void _tracker_view_renderer_background_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
#line 183 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_renderer_background_func (self, cell_layout, cell, tree_model, iter);
#line 478 "tracker-view.c"
}


static void _tracker_view_text_renderer_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
#line 184 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_text_renderer_func (self, cell_layout, cell, tree_model, iter);
#line 485 "tracker-view.c"
}


static void _tracker_view_file_date_renderer_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
#line 193 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_file_date_renderer_func (self, cell_layout, cell, tree_model, iter);
#line 492 "tracker-view.c"
}


static void _tracker_view_file_size_renderer_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
#line 202 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_file_size_renderer_func (self, cell_layout, cell, tree_model, iter);
#line 499 "tracker-view.c"
}


static gboolean _tracker_view_row_selection_func_gtk_tree_selection_func (GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected, gpointer self) {
	gboolean result;
	result = tracker_view_row_selection_func (self, selection, model, path, path_currently_selected);
#line 221 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	return result;
#line 508 "tracker-view.c"
}


static void _tracker_view_category_detail_renderer_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
#line 261 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_category_detail_renderer_func (self, cell_layout, cell, tree_model, iter);
#line 515 "tracker-view.c"
}


static void tracker_view_setup_model (TrackerView* self) {
	TrackerViewDisplay _tmp0_;
#line 138 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (self != NULL);
#line 139 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = self->priv->_display;
#line 139 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	switch (_tmp0_) {
#line 139 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_DISPLAY_FILE_ICONS:
#line 529 "tracker-view.c"
		{
			{
				GtkWidget* _tmp1_;
				GtkIconView* _tmp2_;
				GtkIconView* iv;
				GtkIconView* _tmp3_;
				TrackerResultStore* _tmp4_;
				TrackerResultStore* _tmp5_;
				GtkIconView* _tmp6_;
				GtkIconView* _tmp7_;
				GtkIconView* _tmp8_;
				GtkIconView* _tmp9_;
				GtkIconView* _tmp10_;
				GtkIconView* _tmp11_;
				GtkIconView* _tmp12_;
				GtkIconView* _tmp13_;
#line 141 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp1_ = self->priv->view;
#line 141 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp2_ = _g_object_ref0 (GTK_ICON_VIEW (_tmp1_));
#line 141 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				iv = _tmp2_;
#line 143 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp3_ = iv;
#line 143 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp4_ = tracker_view_get_store (self);
#line 143 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp5_ = _tmp4_;
#line 143 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_icon_view_set_model (_tmp3_, (GtkTreeModel*) _tmp5_);
#line 144 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp6_ = iv;
#line 144 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_icon_view_set_item_width (_tmp6_, 128);
#line 145 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp7_ = iv;
#line 145 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_icon_view_set_item_padding (_tmp7_, 1);
#line 146 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp8_ = iv;
#line 146 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_icon_view_set_row_spacing (_tmp8_, 2);
#line 147 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp9_ = iv;
#line 147 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_icon_view_set_column_spacing (_tmp9_, 2);
#line 148 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp10_ = iv;
#line 148 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_icon_view_set_selection_mode (_tmp10_, GTK_SELECTION_SINGLE);
#line 149 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp11_ = iv;
#line 149 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_icon_view_set_pixbuf_column (_tmp11_, 6);
#line 150 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp12_ = iv;
#line 150 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_icon_view_set_text_column (_tmp12_, -1);
#line 151 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp13_ = iv;
#line 151 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_icon_view_set_tooltip_column (_tmp13_, 5);
#line 153 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (iv);
#line 153 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 596 "tracker-view.c"
			}
		}
#line 139 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_DISPLAY_FILE_LIST:
#line 601 "tracker-view.c"
		{
			{
				GtkTreeViewColumn* col = NULL;
				GtkWidget* _tmp14_;
				GtkTreeView* _tmp15_;
				GtkTreeView* tv;
				GtkTreeView* _tmp16_;
				TrackerResultStore* _tmp17_;
				TrackerResultStore* _tmp18_;
				GtkTreeView* _tmp19_;
				GtkTreeView* _tmp20_;
				GtkTreeView* _tmp21_;
				GtkTreeView* _tmp22_;
				GtkCellRendererPixbuf* _tmp23_;
				GtkCellRendererPixbuf* _tmp24_;
				GtkCellRendererPixbuf* renderer1;
				GtkCellRendererText* _tmp25_;
				GtkCellRendererText* _tmp26_;
				GtkCellRendererText* renderer2;
				GtkTreeViewColumn* _tmp27_;
				GtkTreeViewColumn* _tmp28_;
				GtkTreeViewColumn* _tmp29_;
				GtkTreeViewColumn* _tmp30_;
				GtkCellRendererPixbuf* _tmp31_;
				GtkTreeViewColumn* _tmp32_;
				GtkCellRendererPixbuf* _tmp33_;
				GtkCellRendererPixbuf* _tmp34_;
				GtkCellRendererPixbuf* _tmp35_;
				GtkTreeViewColumn* _tmp36_;
				GtkCellRendererText* _tmp37_;
				GtkCellRendererText* _tmp38_;
				GtkCellRendererText* _tmp39_;
				GtkTreeViewColumn* _tmp40_;
				const gchar* _tmp41_ = NULL;
				GtkTreeViewColumn* _tmp42_;
				GtkTreeViewColumn* _tmp43_;
				GtkTreeViewColumn* _tmp44_;
				GtkCellRendererPixbuf* _tmp45_;
				GtkTreeViewColumn* _tmp46_;
				GtkCellRendererText* _tmp47_;
				GtkTreeView* _tmp48_;
				GtkTreeViewColumn* _tmp49_;
				GtkCellRendererText* _tmp50_;
				GtkCellRendererText* _tmp51_;
				GtkCellRendererText* renderer3;
				GtkCellRendererText* _tmp52_;
				GtkTreeViewColumn* _tmp53_;
				GtkTreeViewColumn* _tmp54_;
				GtkTreeViewColumn* _tmp55_;
				GtkTreeViewColumn* _tmp56_;
				GtkCellRendererText* _tmp57_;
				GtkTreeViewColumn* _tmp58_;
				const gchar* _tmp59_ = NULL;
				GtkTreeViewColumn* _tmp60_;
				GtkCellRendererText* _tmp61_;
				GtkTreeView* _tmp62_;
				GtkTreeViewColumn* _tmp63_;
				GtkCellRendererText* _tmp64_;
				GtkCellRendererText* _tmp65_;
				GtkCellRendererText* renderer4;
				GtkCellRendererText* _tmp66_;
				GtkTreeViewColumn* _tmp67_;
				GtkTreeViewColumn* _tmp68_;
				GtkTreeViewColumn* _tmp69_;
				GtkTreeViewColumn* _tmp70_;
				GtkCellRendererText* _tmp71_;
				GtkTreeViewColumn* _tmp72_;
				const gchar* _tmp73_ = NULL;
				GtkTreeViewColumn* _tmp74_;
				GtkCellRendererText* _tmp75_;
				GtkTreeView* _tmp76_;
				GtkTreeViewColumn* _tmp77_;
#line 158 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp14_ = self->priv->view;
#line 158 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp15_ = _g_object_ref0 (GTK_TREE_VIEW (_tmp14_));
#line 158 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				tv = _tmp15_;
#line 160 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp16_ = tv;
#line 160 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp17_ = tracker_view_get_store (self);
#line 160 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp18_ = _tmp17_;
#line 160 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_model (_tmp16_, (GtkTreeModel*) _tmp18_);
#line 161 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp19_ = tv;
#line 161 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_tooltip_column (_tmp19_, 6);
#line 162 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp20_ = tv;
#line 162 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_rules_hint (_tmp20_, FALSE);
#line 163 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp21_ = tv;
#line 163 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_grid_lines (_tmp21_, GTK_TREE_VIEW_GRID_LINES_VERTICAL);
#line 164 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp22_ = tv;
#line 164 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_headers_visible (_tmp22_, TRUE);
#line 166 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp23_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 166 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp24_ = g_object_ref_sink (_tmp23_);
#line 166 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				renderer1 = _tmp24_;
#line 167 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp25_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 167 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp26_ = g_object_ref_sink (_tmp25_);
#line 167 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				renderer2 = _tmp26_;
#line 169 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp27_ = gtk_tree_view_column_new ();
#line 169 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp28_ = g_object_ref_sink (_tmp27_);
#line 169 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (col);
#line 169 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				col = _tmp28_;
#line 170 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp29_ = col;
#line 170 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_sizing (_tmp29_, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
#line 171 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp30_ = col;
#line 171 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp31_ = renderer1;
#line 171 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp30_, (GtkCellRenderer*) _tmp31_, FALSE);
#line 172 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp32_ = col;
#line 172 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp33_ = renderer1;
#line 172 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp32_, (GtkCellRenderer*) _tmp33_, "pixbuf", 7);
#line 173 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp34_ = renderer1;
#line 173 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				g_object_set ((GtkCellRenderer*) _tmp34_, "xpad", (guint) 5, NULL);
#line 174 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp35_ = renderer1;
#line 174 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				g_object_set ((GtkCellRenderer*) _tmp35_, "ypad", (guint) 5, NULL);
#line 176 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp36_ = col;
#line 176 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp37_ = renderer2;
#line 176 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp36_, (GtkCellRenderer*) _tmp37_, TRUE);
#line 177 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp38_ = renderer2;
#line 177 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_renderer_text_set_fixed_height_from_font (_tmp38_, 2);
#line 178 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp39_ = renderer2;
#line 178 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				g_object_set (_tmp39_, "ellipsize", PANGO_ELLIPSIZE_MIDDLE, NULL);
#line 180 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp40_ = col;
#line 180 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp41_ = _ ("File");
#line 180 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_title (_tmp40_, _tmp41_);
#line 181 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp42_ = col;
#line 181 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_resizable (_tmp42_, TRUE);
#line 182 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp43_ = col;
#line 182 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_expand (_tmp43_, TRUE);
#line 183 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp44_ = col;
#line 183 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp45_ = renderer1;
#line 183 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp44_, (GtkCellRenderer*) _tmp45_, _tracker_view_renderer_background_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 184 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp46_ = col;
#line 184 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp47_ = renderer2;
#line 184 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp46_, (GtkCellRenderer*) _tmp47_, _tracker_view_text_renderer_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 185 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp48_ = tv;
#line 185 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp49_ = col;
#line 185 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_append_column (_tmp48_, _tmp49_);
#line 187 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp50_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 187 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp51_ = g_object_ref_sink (_tmp50_);
#line 187 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				renderer3 = _tmp51_;
#line 188 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp52_ = renderer3;
#line 188 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_renderer_text_set_fixed_height_from_font (_tmp52_, 2);
#line 189 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp53_ = gtk_tree_view_column_new ();
#line 189 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp54_ = g_object_ref_sink (_tmp53_);
#line 189 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (col);
#line 189 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				col = _tmp54_;
#line 190 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp55_ = col;
#line 190 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_sizing (_tmp55_, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
#line 191 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp56_ = col;
#line 191 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp57_ = renderer3;
#line 191 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp56_, (GtkCellRenderer*) _tmp57_, TRUE);
#line 192 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp58_ = col;
#line 192 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp59_ = _ ("Last Changed");
#line 192 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_title (_tmp58_, _tmp59_);
#line 193 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp60_ = col;
#line 193 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp61_ = renderer3;
#line 193 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp60_, (GtkCellRenderer*) _tmp61_, _tracker_view_file_date_renderer_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 194 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp62_ = tv;
#line 194 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp63_ = col;
#line 194 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_append_column (_tmp62_, _tmp63_);
#line 196 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp64_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 196 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp65_ = g_object_ref_sink (_tmp64_);
#line 196 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				renderer4 = _tmp65_;
#line 197 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp66_ = renderer4;
#line 197 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_renderer_text_set_fixed_height_from_font (_tmp66_, 2);
#line 198 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp67_ = gtk_tree_view_column_new ();
#line 198 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp68_ = g_object_ref_sink (_tmp67_);
#line 198 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (col);
#line 198 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				col = _tmp68_;
#line 199 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp69_ = col;
#line 199 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_sizing (_tmp69_, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
#line 200 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp70_ = col;
#line 200 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp71_ = renderer4;
#line 200 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp70_, (GtkCellRenderer*) _tmp71_, TRUE);
#line 201 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp72_ = col;
#line 201 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp73_ = _ ("Size");
#line 201 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_title (_tmp72_, _tmp73_);
#line 202 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp74_ = col;
#line 202 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp75_ = renderer4;
#line 202 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp74_, (GtkCellRenderer*) _tmp75_, _tracker_view_file_size_renderer_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 203 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp76_ = tv;
#line 203 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp77_ = col;
#line 203 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_append_column (_tmp76_, _tmp77_);
#line 205 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (renderer4);
#line 205 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (renderer3);
#line 205 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (renderer2);
#line 205 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (renderer1);
#line 205 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (tv);
#line 205 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (col);
#line 205 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 900 "tracker-view.c"
			}
		}
#line 139 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_DISPLAY_CATEGORIES:
#line 905 "tracker-view.c"
		{
			{
				GtkTreeViewColumn* col = NULL;
				GtkWidget* _tmp78_;
				GtkTreeView* _tmp79_;
				GtkTreeView* tv;
				GtkTreeSelection* selection = NULL;
				GtkTreeView* _tmp80_;
				TrackerResultStore* _tmp81_;
				TrackerResultStore* _tmp82_;
				GtkTreeView* _tmp83_;
				GtkTreeView* _tmp84_;
				GtkTreeView* _tmp85_;
				GtkTreeView* _tmp86_;
				GtkTreeView* _tmp87_;
				GtkTreeView* _tmp88_;
				GtkTreeSelection* _tmp89_ = NULL;
				GtkTreeSelection* _tmp90_;
				GtkTreeSelection* _tmp91_;
				GtkTreeViewColumn* _tmp92_;
				GtkTreeViewColumn* _tmp93_;
				GtkTreeViewColumn* _tmp94_;
				GtkTreeViewColumn* _tmp95_;
				GtkCellRendererPixbuf* _tmp96_;
				GtkCellRendererPixbuf* _tmp97_;
				GtkCellRendererPixbuf* renderer1;
				GtkTreeViewColumn* _tmp98_;
				GtkCellRendererPixbuf* _tmp99_;
				GtkTreeViewColumn* _tmp100_;
				GtkCellRendererPixbuf* _tmp101_;
				GtkTreeViewColumn* _tmp102_;
				GtkCellRendererPixbuf* _tmp103_;
				GtkCellRendererPixbuf* _tmp104_;
				GtkCellRendererPixbuf* _tmp105_;
				GtkCellRendererText* _tmp106_;
				GtkCellRendererText* _tmp107_;
				GtkCellRendererText* renderer2;
				GtkTreeViewColumn* _tmp108_;
				GtkCellRendererText* _tmp109_;
				GtkTreeViewColumn* _tmp110_;
				GtkCellRendererText* _tmp111_;
				GtkCellRendererText* _tmp112_;
				GtkCellRendererText* _tmp113_;
				GtkTreeView* _tmp114_;
				GtkTreeViewColumn* _tmp115_;
				GtkCellRendererText* _tmp116_;
				GtkCellRendererText* _tmp117_;
				GtkCellRendererText* renderer4;
				GtkCellRendererText* _tmp118_;
				GtkCellRendererText* _tmp119_;
				GtkCellRendererText* _tmp120_;
				GtkTreeViewColumn* _tmp121_;
				GtkTreeViewColumn* _tmp122_;
				GtkTreeViewColumn* _tmp123_;
				GtkTreeViewColumn* _tmp124_;
				GtkTreeViewColumn* _tmp125_;
				GtkCellRendererText* _tmp126_;
				GtkTreeViewColumn* _tmp127_;
				GtkCellRendererText* _tmp128_;
				GtkTreeView* _tmp129_;
				GtkTreeViewColumn* _tmp130_;
#line 210 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp78_ = self->priv->view;
#line 210 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp79_ = _g_object_ref0 (GTK_TREE_VIEW (_tmp78_));
#line 210 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				tv = _tmp79_;
#line 213 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp80_ = tv;
#line 213 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp81_ = tracker_view_get_store (self);
#line 213 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp82_ = _tmp81_;
#line 213 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_model (_tmp80_, (GtkTreeModel*) _tmp82_);
#line 214 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp83_ = tv;
#line 214 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_tooltip_column (_tmp83_, 5);
#line 215 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp84_ = tv;
#line 215 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_rules_hint (_tmp84_, FALSE);
#line 216 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp85_ = tv;
#line 216 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_grid_lines (_tmp85_, GTK_TREE_VIEW_GRID_LINES_NONE);
#line 217 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp86_ = tv;
#line 217 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_headers_visible (_tmp86_, FALSE);
#line 218 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp87_ = tv;
#line 218 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_set_show_expanders (_tmp87_, FALSE);
#line 220 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp88_ = tv;
#line 220 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp89_ = gtk_tree_view_get_selection (_tmp88_);
#line 220 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp90_ = _g_object_ref0 (_tmp89_);
#line 220 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (selection);
#line 220 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				selection = _tmp90_;
#line 221 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp91_ = selection;
#line 221 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_selection_set_select_function (_tmp91_, _tracker_view_row_selection_func_gtk_tree_selection_func, g_object_ref (self), g_object_unref);
#line 223 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp92_ = gtk_tree_view_column_new ();
#line 223 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp93_ = g_object_ref_sink (_tmp92_);
#line 223 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (col);
#line 223 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				col = _tmp93_;
#line 224 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp94_ = col;
#line 224 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_sizing (_tmp94_, GTK_TREE_VIEW_COLUMN_FIXED);
#line 225 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp95_ = col;
#line 225 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_expand (_tmp95_, TRUE);
#line 227 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp96_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 227 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp97_ = g_object_ref_sink (_tmp96_);
#line 227 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				renderer1 = _tmp97_;
#line 228 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp98_ = col;
#line 228 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp99_ = renderer1;
#line 228 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp98_, (GtkCellRenderer*) _tmp99_, FALSE);
#line 229 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp100_ = col;
#line 229 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp101_ = renderer1;
#line 229 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp100_, (GtkCellRenderer*) _tmp101_, "pixbuf", 6);
#line 230 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp102_ = col;
#line 230 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp103_ = renderer1;
#line 230 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp102_, (GtkCellRenderer*) _tmp103_, _tracker_view_renderer_background_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 231 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp104_ = renderer1;
#line 231 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				g_object_set ((GtkCellRenderer*) _tmp104_, "xpad", (guint) 5, NULL);
#line 232 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp105_ = renderer1;
#line 232 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				g_object_set ((GtkCellRenderer*) _tmp105_, "ypad", (guint) 5, NULL);
#line 234 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp106_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 234 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp107_ = g_object_ref_sink (_tmp106_);
#line 234 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				renderer2 = _tmp107_;
#line 235 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp108_ = col;
#line 235 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp109_ = renderer2;
#line 235 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp108_, (GtkCellRenderer*) _tmp109_, TRUE);
#line 236 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp110_ = col;
#line 236 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp111_ = renderer2;
#line 236 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp110_, (GtkCellRenderer*) _tmp111_, _tracker_view_text_renderer_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 237 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp112_ = renderer2;
#line 237 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_renderer_text_set_fixed_height_from_font (_tmp112_, 2);
#line 238 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp113_ = renderer2;
#line 238 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				g_object_set (_tmp113_, "ellipsize", PANGO_ELLIPSIZE_MIDDLE, NULL);
#line 242 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp114_ = tv;
#line 242 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp115_ = col;
#line 242 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_append_column (_tmp114_, _tmp115_);
#line 252 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp116_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 252 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp117_ = g_object_ref_sink (_tmp116_);
#line 252 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				renderer4 = _tmp117_;
#line 253 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp118_ = renderer4;
#line 253 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_renderer_text_set_fixed_height_from_font (_tmp118_, 2);
#line 254 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp119_ = renderer4;
#line 254 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				g_object_set (_tmp119_, "alignment", PANGO_ALIGN_RIGHT, NULL);
#line 255 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp120_ = renderer4;
#line 255 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				g_object_set ((GtkCellRenderer*) _tmp120_, "xalign", (gfloat) 1, NULL);
#line 257 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp121_ = gtk_tree_view_column_new ();
#line 257 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp122_ = g_object_ref_sink (_tmp121_);
#line 257 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (col);
#line 257 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				col = _tmp122_;
#line 258 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp123_ = col;
#line 258 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_min_width (_tmp123_, 80);
#line 259 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp124_ = col;
#line 259 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_column_set_sizing (_tmp124_, GTK_TREE_VIEW_COLUMN_FIXED);
#line 260 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp125_ = col;
#line 260 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp126_ = renderer4;
#line 260 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp125_, (GtkCellRenderer*) _tmp126_, TRUE);
#line 261 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp127_ = col;
#line 261 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp128_ = renderer4;
#line 261 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp127_, (GtkCellRenderer*) _tmp128_, _tracker_view_category_detail_renderer_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 262 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp129_ = tv;
#line 262 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp130_ = col;
#line 262 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				gtk_tree_view_append_column (_tmp129_, _tmp130_);
#line 264 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (renderer4);
#line 264 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (renderer2);
#line 264 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (renderer1);
#line 264 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (selection);
#line 264 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (tv);
#line 264 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_object_unref0 (col);
#line 264 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 1161 "tracker-view.c"
			}
		}
		default:
#line 139 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		break;
#line 1167 "tracker-view.c"
	}
}


static void tracker_view_renderer_background_func (TrackerView* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter) {
	GdkColor color = {0};
	GtkStyle* style = NULL;
	GtkTreePath* path = NULL;
	GtkWidget* _tmp0_;
	GtkStyle* _tmp1_ = NULL;
	GtkStyle* _tmp2_;
	GtkStyle* _tmp3_;
	GdkColor* _tmp4_;
	gint _tmp4__length1;
	GdkColor _tmp5_;
	GdkColor _tmp6_;
	guint16 _tmp7_;
	GdkColor _tmp8_;
	guint16 _tmp9_;
	GdkColor _tmp10_;
	guint16 _tmp11_;
	gint sum_normal;
	GtkStyle* _tmp12_;
	GdkColor* _tmp13_;
	gint _tmp13__length1;
	GdkColor _tmp14_;
	GdkColor _tmp15_;
	guint16 _tmp16_;
	GdkColor _tmp17_;
	guint16 _tmp18_;
	GdkColor _tmp19_;
	guint16 _tmp20_;
	gint sum_selected;
	GtkStyle* _tmp21_;
	GdkColor* _tmp22_;
	gint _tmp22__length1;
	GdkColor _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GtkTreeModel* _tmp56_;
	GtkTreeIter _tmp57_;
	GtkTreePath* _tmp58_ = NULL;
	GtkTreePath* _tmp59_;
	gint* _tmp60_ = NULL;
	gint _tmp61_;
#line 269 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (self != NULL);
#line 269 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (cell_layout != NULL);
#line 269 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (cell != NULL);
#line 269 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (tree_model != NULL);
#line 269 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (iter != NULL);
#line 277 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = self->priv->view;
#line 277 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp1_ = gtk_widget_get_style (_tmp0_);
#line 277 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 277 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_object_unref0 (style);
#line 277 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	style = _tmp2_;
#line 279 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp3_ = style;
#line 279 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp4_ = _tmp3_->base;
#line 279 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp4__length1 = -1;
#line 279 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp5_ = _tmp4_[GTK_STATE_SELECTED];
#line 279 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	color = _tmp5_;
#line 280 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp6_ = color;
#line 280 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp7_ = _tmp6_.red;
#line 280 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp8_ = color;
#line 280 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp9_ = _tmp8_.green;
#line 280 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp10_ = color;
#line 280 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp11_ = _tmp10_.blue;
#line 280 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	sum_normal = (gint) ((_tmp7_ + _tmp9_) + _tmp11_);
#line 281 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp12_ = style;
#line 281 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp13_ = _tmp12_->base;
#line 281 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp13__length1 = -1;
#line 281 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp14_ = _tmp13_[GTK_STATE_NORMAL];
#line 281 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	color = _tmp14_;
#line 282 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp15_ = color;
#line 282 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp16_ = _tmp15_.red;
#line 282 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp17_ = color;
#line 282 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp18_ = _tmp17_.green;
#line 282 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp19_ = color;
#line 282 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp20_ = _tmp19_.blue;
#line 282 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	sum_selected = (gint) ((_tmp16_ + _tmp18_) + _tmp20_);
#line 283 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp21_ = style;
#line 283 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp22_ = _tmp21_->text_aa;
#line 283 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp22__length1 = -1;
#line 283 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp23_ = _tmp22_[GTK_STATE_INSENSITIVE];
#line 283 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	color = _tmp23_;
#line 285 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp24_ = sum_normal;
#line 285 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp25_ = sum_selected;
#line 285 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp24_ < _tmp25_) {
#line 1297 "tracker-view.c"
		GdkColor _tmp26_;
		guint16 _tmp27_;
		GtkStyle* _tmp28_;
		GdkColor _tmp29_;
		guint16 _tmp30_;
		GdkColor _tmp31_;
		guint16 _tmp32_;
		GtkStyle* _tmp33_;
		GdkColor _tmp34_;
		guint16 _tmp35_;
		GdkColor _tmp36_;
		guint16 _tmp37_;
		GtkStyle* _tmp38_;
		GdkColor _tmp39_;
		guint16 _tmp40_;
#line 287 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp26_ = color;
#line 287 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp27_ = _tmp26_.red;
#line 287 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp28_ = style;
#line 287 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp29_ = _tmp28_->white;
#line 287 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp30_ = _tmp29_.red;
#line 287 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		color.red = (guint16) ((_tmp27_ + _tmp30_) / 2);
#line 288 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp31_ = color;
#line 288 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp32_ = _tmp31_.green;
#line 288 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp33_ = style;
#line 288 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp34_ = _tmp33_->white;
#line 288 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp35_ = _tmp34_.green;
#line 288 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		color.green = (guint16) ((_tmp32_ + _tmp35_) / 2);
#line 289 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp36_ = color;
#line 289 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp37_ = _tmp36_.blue;
#line 289 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp38_ = style;
#line 289 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp39_ = _tmp38_->white;
#line 289 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp40_ = _tmp39_.blue;
#line 289 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		color.blue = (guint16) ((_tmp37_ + _tmp40_) / 2);
#line 1349 "tracker-view.c"
	} else {
		GdkColor _tmp41_;
		guint16 _tmp42_;
		GtkStyle* _tmp43_;
		GdkColor _tmp44_;
		guint16 _tmp45_;
		GdkColor _tmp46_;
		guint16 _tmp47_;
		GtkStyle* _tmp48_;
		GdkColor _tmp49_;
		guint16 _tmp50_;
		GdkColor _tmp51_;
		guint16 _tmp52_;
		GtkStyle* _tmp53_;
		GdkColor _tmp54_;
		guint16 _tmp55_;
#line 292 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp41_ = color;
#line 292 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp42_ = _tmp41_.red;
#line 292 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp43_ = style;
#line 292 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp44_ = _tmp43_->black;
#line 292 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp45_ = _tmp44_.red;
#line 292 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		color.red = (guint16) ((_tmp42_ + _tmp45_) / 2);
#line 293 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp46_ = color;
#line 293 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp47_ = _tmp46_.green;
#line 293 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp48_ = style;
#line 293 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp49_ = _tmp48_->black;
#line 293 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp50_ = _tmp49_.green;
#line 293 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		color.green = (guint16) ((_tmp47_ + _tmp50_) / 2);
#line 294 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp51_ = color;
#line 294 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp52_ = _tmp51_.blue;
#line 294 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp53_ = style;
#line 294 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp54_ = _tmp53_->black;
#line 294 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp55_ = _tmp54_.blue;
#line 294 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		color.blue = (guint16) ((_tmp52_ + _tmp55_) / 2);
#line 1402 "tracker-view.c"
	}
#line 297 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp56_ = tree_model;
#line 297 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp57_ = *iter;
#line 297 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp58_ = gtk_tree_model_get_path (_tmp56_, &_tmp57_);
#line 297 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_gtk_tree_path_free0 (path);
#line 297 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	path = _tmp58_;
#line 300 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp59_ = path;
#line 300 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp60_ = gtk_tree_path_get_indices (_tmp59_);
#line 300 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp61_ = _tmp60_[0];
#line 300 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if ((_tmp61_ % 2) != 0) {
#line 1422 "tracker-view.c"
		GtkCellRenderer* _tmp62_;
		GdkColor _tmp63_;
#line 301 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp62_ = cell;
#line 301 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp63_ = color;
#line 301 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_object_set ((GObject*) _tmp62_, "cell-background-gdk", &_tmp63_, NULL);
#line 1431 "tracker-view.c"
	} else {
		GtkCellRenderer* _tmp64_;
#line 303 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp64_ = cell;
#line 303 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_object_set ((GObject*) _tmp64_, "cell-background-gdk", NULL, NULL);
#line 1438 "tracker-view.c"
	}
#line 269 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_gtk_tree_path_free0 (path);
#line 269 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_object_unref0 (style);
#line 1444 "tracker-view.c"
}


static void tracker_view_text_renderer_func (TrackerView* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter) {
	gchar* text = NULL;
	gchar* subtext = NULL;
	gchar* markup;
	gint n_children = 0;
	GtkCellLayout* _tmp0_;
	GtkCellRenderer* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeIter _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_;
	GtkCellRenderer* _tmp46_;
	const gchar* _tmp47_;
#line 307 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (self != NULL);
#line 307 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (cell_layout != NULL);
#line 307 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (cell != NULL);
#line 307 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (tree_model != NULL);
#line 307 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (iter != NULL);
#line 312 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	markup = NULL;
#line 315 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = cell_layout;
#line 315 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp1_ = cell;
#line 315 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp2_ = tree_model;
#line 315 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp3_ = *iter;
#line 315 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_renderer_background_func (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_);
#line 316 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp4_ = tree_model;
#line 316 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp5_ = *iter;
#line 316 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp6_ = gtk_tree_model_iter_n_children (_tmp4_, &_tmp5_);
#line 316 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	n_children = _tmp6_;
#line 318 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp7_ = n_children;
#line 318 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp7_ > 0) {
#line 1497 "tracker-view.c"
		TrackerQueryType type = 0;
		gchar* cat;
		GtkTreeModel* _tmp8_;
		GtkTreeIter _tmp9_;
		TrackerQueryType _tmp10_;
		const gchar* _tmp27_;
		gint _tmp28_;
		const gchar* _tmp29_ = NULL;
		gchar* _tmp30_ = NULL;
#line 321 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		cat = NULL;
#line 323 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp8_ = tree_model;
#line 323 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp9_ = *iter;
#line 323 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		gtk_tree_model_get (_tmp8_, &_tmp9_, 7, &type, -1, -1);
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp10_ = type;
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		switch (_tmp10_) {
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			case TRACKER_QUERY_TYPE_APPLICATIONS:
#line 1521 "tracker-view.c"
			{
				const gchar* _tmp11_ = NULL;
				gchar* _tmp12_;
#line 326 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp11_ = _ ("Applications");
#line 326 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp12_ = g_strdup (_tmp11_);
#line 326 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (cat);
#line 326 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				cat = _tmp12_;
#line 327 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 1535 "tracker-view.c"
			}
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			case TRACKER_QUERY_TYPE_MUSIC:
#line 1539 "tracker-view.c"
			{
				const gchar* _tmp13_ = NULL;
				gchar* _tmp14_;
#line 329 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp13_ = _ ("Music");
#line 329 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 329 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (cat);
#line 329 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				cat = _tmp14_;
#line 330 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 1553 "tracker-view.c"
			}
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			case TRACKER_QUERY_TYPE_IMAGES:
#line 1557 "tracker-view.c"
			{
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_;
#line 332 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp15_ = _ ("Images");
#line 332 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 332 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (cat);
#line 332 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				cat = _tmp16_;
#line 333 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 1571 "tracker-view.c"
			}
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			case TRACKER_QUERY_TYPE_VIDEOS:
#line 1575 "tracker-view.c"
			{
				const gchar* _tmp17_ = NULL;
				gchar* _tmp18_;
#line 335 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp17_ = _ ("Videos");
#line 335 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp18_ = g_strdup (_tmp17_);
#line 335 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (cat);
#line 335 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				cat = _tmp18_;
#line 336 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 1589 "tracker-view.c"
			}
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			case TRACKER_QUERY_TYPE_DOCUMENTS:
#line 1593 "tracker-view.c"
			{
				const gchar* _tmp19_ = NULL;
				gchar* _tmp20_;
#line 338 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp19_ = _ ("Documents");
#line 338 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp20_ = g_strdup (_tmp19_);
#line 338 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (cat);
#line 338 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				cat = _tmp20_;
#line 339 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 1607 "tracker-view.c"
			}
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			case TRACKER_QUERY_TYPE_MAIL:
#line 1611 "tracker-view.c"
			{
				const gchar* _tmp21_ = NULL;
				gchar* _tmp22_;
#line 341 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp21_ = _ ("Mail");
#line 341 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp22_ = g_strdup (_tmp21_);
#line 341 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (cat);
#line 341 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				cat = _tmp22_;
#line 342 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 1625 "tracker-view.c"
			}
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			case TRACKER_QUERY_TYPE_FOLDERS:
#line 1629 "tracker-view.c"
			{
				const gchar* _tmp23_ = NULL;
				gchar* _tmp24_;
#line 344 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp23_ = _ ("Folders");
#line 344 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp24_ = g_strdup (_tmp23_);
#line 344 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (cat);
#line 344 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				cat = _tmp24_;
#line 345 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 1643 "tracker-view.c"
			}
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			case TRACKER_QUERY_TYPE_BOOKMARKS:
#line 1647 "tracker-view.c"
			{
				const gchar* _tmp25_ = NULL;
				gchar* _tmp26_;
#line 347 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp25_ = _ ("Bookmarks");
#line 347 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp26_ = g_strdup (_tmp25_);
#line 347 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (cat);
#line 347 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				cat = _tmp26_;
#line 348 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				break;
#line 1661 "tracker-view.c"
			}
			default:
#line 324 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			break;
#line 1666 "tracker-view.c"
		}
#line 351 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp27_ = cat;
#line 351 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp28_ = n_children;
#line 351 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp29_ = _ ("Items");
#line 351 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp30_ = g_strdup_printf ("<b><big>%s</big></b> <small>(%d %s)</small>", _tmp27_, _tmp28_, _tmp29_);
#line 351 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_g_free0 (markup);
#line 351 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		markup = _tmp30_;
#line 318 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_g_free0 (cat);
#line 1682 "tracker-view.c"
	} else {
		GtkTreeModel* _tmp31_;
		GtkTreeIter _tmp32_;
		const gchar* _tmp33_;
#line 354 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp31_ = tree_model;
#line 354 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp32_ = *iter;
#line 354 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		gtk_tree_model_get (_tmp31_, &_tmp32_, 2, &text, 3, &subtext, -1, -1);
#line 356 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp33_ = text;
#line 356 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		if (_tmp33_ != NULL) {
#line 1697 "tracker-view.c"
			const gchar* _tmp34_;
			gchar* _tmp35_ = NULL;
			const gchar* _tmp36_;
#line 357 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp34_ = text;
#line 357 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp35_ = g_markup_escape_text (_tmp34_, (gssize) (-1));
#line 357 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_free0 (markup);
#line 357 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			markup = _tmp35_;
#line 359 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp36_ = subtext;
#line 359 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			if (_tmp36_ != NULL) {
#line 1713 "tracker-view.c"
				const gchar* _tmp37_;
				const gchar* _tmp38_;
				gchar* _tmp39_ = NULL;
				gchar* _tmp40_;
				gchar* _tmp41_ = NULL;
				gchar* _tmp42_;
				gchar* _tmp43_;
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp37_ = markup;
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp38_ = subtext;
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp39_ = g_markup_escape_text (_tmp38_, (gssize) (-1));
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp40_ = _tmp39_;
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp41_ = g_strdup_printf ("\n<small><span color='grey'>%s</span></small>", _tmp40_);
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp42_ = _tmp41_;
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_tmp43_ = g_strconcat (_tmp37_, _tmp42_, NULL);
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (markup);
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				markup = _tmp43_;
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (_tmp42_);
#line 360 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
				_g_free0 (_tmp40_);
#line 1743 "tracker-view.c"
			}
		} else {
			const gchar* _tmp44_ = NULL;
			gchar* _tmp45_ = NULL;
#line 363 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp44_ = _ ("Loading...");
#line 363 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp45_ = g_strdup_printf ("<span color='grey'>%s</span>\n", _tmp44_);
#line 363 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_free0 (markup);
#line 363 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			markup = _tmp45_;
#line 1756 "tracker-view.c"
		}
	}
#line 367 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp46_ = cell;
#line 367 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp47_ = markup;
#line 367 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_object_set ((GObject*) _tmp46_, "markup", _tmp47_, NULL);
#line 307 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_free0 (markup);
#line 307 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_free0 (subtext);
#line 307 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_free0 (text);
#line 1771 "tracker-view.c"
}


static void tracker_view_file_size_renderer_func (TrackerView* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter) {
	gchar* size = NULL;
	GtkCellLayout* _tmp0_;
	GtkCellRenderer* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeIter _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	const gchar* _tmp6_;
	GtkCellRenderer* _tmp10_;
	const gchar* _tmp11_;
#line 370 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (self != NULL);
#line 370 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (cell_layout != NULL);
#line 370 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (cell != NULL);
#line 370 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (tree_model != NULL);
#line 370 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (iter != NULL);
#line 376 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = cell_layout;
#line 376 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp1_ = cell;
#line 376 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp2_ = tree_model;
#line 376 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp3_ = *iter;
#line 376 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_renderer_background_func (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_);
#line 377 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp4_ = tree_model;
#line 377 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp5_ = *iter;
#line 377 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	gtk_tree_model_get (_tmp4_, &_tmp5_, 4, &size, -1, -1);
#line 379 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp6_ = size;
#line 379 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp6_ != NULL) {
#line 1816 "tracker-view.c"
		const gchar* _tmp7_;
		gint _tmp8_ = 0;
		gchar* _tmp9_ = NULL;
#line 380 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp7_ = size;
#line 380 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp8_ = atoi (_tmp7_);
#line 380 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp9_ = g_format_size_for_display ((gint64) _tmp8_);
#line 380 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_g_free0 (size);
#line 380 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		size = _tmp9_;
#line 1830 "tracker-view.c"
	}
#line 383 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp10_ = cell;
#line 383 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp11_ = size;
#line 383 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_object_set ((GObject*) _tmp10_, "text", _tmp11_, NULL);
#line 370 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_free0 (size);
#line 1840 "tracker-view.c"
}


static void tracker_view_file_date_renderer_func (TrackerView* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter) {
	gchar* date = NULL;
	GtkCellLayout* _tmp0_;
	GtkCellRenderer* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeIter _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	const gchar* _tmp6_;
	GtkCellRenderer* _tmp9_;
	const gchar* _tmp10_;
#line 386 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (self != NULL);
#line 386 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (cell_layout != NULL);
#line 386 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (cell != NULL);
#line 386 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (tree_model != NULL);
#line 386 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (iter != NULL);
#line 392 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = cell_layout;
#line 392 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp1_ = cell;
#line 392 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp2_ = tree_model;
#line 392 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp3_ = *iter;
#line 392 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_renderer_background_func (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_);
#line 393 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp4_ = tree_model;
#line 393 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp5_ = *iter;
#line 393 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	gtk_tree_model_get (_tmp4_, &_tmp5_, 5, &date, -1, -1);
#line 395 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp6_ = date;
#line 395 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp6_ != NULL) {
#line 1885 "tracker-view.c"
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
#line 396 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp7_ = date;
#line 396 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp8_ = tracker_time_format_from_iso8601 (_tmp7_);
#line 396 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_g_free0 (date);
#line 396 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		date = _tmp8_;
#line 1896 "tracker-view.c"
	}
#line 399 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp9_ = cell;
#line 399 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp10_ = date;
#line 399 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_object_set ((GObject*) _tmp9_, "text", _tmp10_, NULL);
#line 386 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_free0 (date);
#line 1906 "tracker-view.c"
}


static void tracker_view_category_detail_renderer_func (TrackerView* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter) {
	TrackerQueryType category = 0;
	gchar* markup;
	gchar* detail = NULL;
	GtkCellLayout* _tmp0_;
	GtkCellRenderer* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreeIter _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	const gchar* _tmp6_;
	TrackerQueryType _tmp8_;
	const gchar* _tmp21_;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_;
	gchar* _tmp24_ = NULL;
	GtkCellRenderer* _tmp25_;
	const gchar* _tmp26_;
#line 402 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (self != NULL);
#line 402 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (cell_layout != NULL);
#line 402 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (cell != NULL);
#line 402 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (tree_model != NULL);
#line 402 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (iter != NULL);
#line 407 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	markup = NULL;
#line 410 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = cell_layout;
#line 410 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp1_ = cell;
#line 410 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp2_ = tree_model;
#line 410 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp3_ = *iter;
#line 410 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_renderer_background_func (self, _tmp0_, _tmp1_, _tmp2_, &_tmp3_);
#line 411 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp4_ = tree_model;
#line 411 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp5_ = *iter;
#line 411 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	gtk_tree_model_get (_tmp4_, &_tmp5_, 4, &detail, 7, &category, -1, -1);
#line 413 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp6_ = detail;
#line 413 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp6_ == NULL) {
#line 1960 "tracker-view.c"
		GtkCellRenderer* _tmp7_;
#line 414 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp7_ = cell;
#line 414 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_object_set ((GObject*) _tmp7_, "markup", NULL, NULL);
#line 415 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_g_free0 (detail);
#line 415 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_g_free0 (markup);
#line 415 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		return;
#line 1972 "tracker-view.c"
	}
#line 418 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp8_ = category;
#line 418 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	switch (_tmp8_) {
#line 418 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_QUERY_TYPE_FOLDERS:
#line 418 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_QUERY_TYPE_MAIL:
#line 418 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_QUERY_TYPE_BOOKMARKS:
#line 1984 "tracker-view.c"
		{
			const gchar* _tmp9_;
			gchar* _tmp10_ = NULL;
#line 422 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp9_ = detail;
#line 422 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp10_ = tracker_time_format_from_iso8601 (_tmp9_);
#line 422 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_free0 (detail);
#line 422 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			detail = _tmp10_;
#line 423 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			break;
#line 1998 "tracker-view.c"
		}
#line 418 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_QUERY_TYPE_MUSIC:
#line 418 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_QUERY_TYPE_VIDEOS:
#line 2004 "tracker-view.c"
		{
			const gchar* _tmp11_;
			gchar* _tmp12_ = NULL;
#line 426 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp11_ = detail;
#line 426 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp12_ = tracker_time_format_from_seconds (_tmp11_);
#line 426 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_free0 (detail);
#line 426 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			detail = _tmp12_;
#line 427 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			break;
#line 2018 "tracker-view.c"
		}
#line 418 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_QUERY_TYPE_DOCUMENTS:
#line 2022 "tracker-view.c"
		{
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			const gchar* _tmp16_ = NULL;
			gchar* _tmp17_;
#line 429 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp13_ = detail;
#line 429 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp14_ = g_strconcat (_tmp13_, " ", NULL);
#line 429 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp15_ = _tmp14_;
#line 429 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp16_ = _ ("Pages");
#line 429 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
#line 429 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_free0 (detail);
#line 429 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			detail = _tmp17_;
#line 429 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_free0 (_tmp15_);
#line 430 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			break;
#line 2047 "tracker-view.c"
		}
#line 418 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_QUERY_TYPE_IMAGES:
#line 2051 "tracker-view.c"
		{
			const gchar* _tmp18_;
			gint _tmp19_ = 0;
			gchar* _tmp20_ = NULL;
#line 432 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp18_ = detail;
#line 432 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp19_ = atoi (_tmp18_);
#line 432 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_tmp20_ = g_format_size_for_display ((gint64) _tmp19_);
#line 432 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			_g_free0 (detail);
#line 432 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			detail = _tmp20_;
#line 433 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
			break;
#line 2068 "tracker-view.c"
		}
		default:
#line 418 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		break;
#line 2073 "tracker-view.c"
	}
#line 436 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp21_ = detail;
#line 436 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp22_ = g_markup_escape_text (_tmp21_, (gssize) (-1));
#line 436 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp23_ = _tmp22_;
#line 436 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp24_ = g_strdup_printf ("<span color='grey'><small>%s</small></span>", _tmp23_);
#line 436 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_free0 (markup);
#line 436 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	markup = _tmp24_;
#line 436 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_free0 (_tmp23_);
#line 437 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp25_ = cell;
#line 437 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp26_ = markup;
#line 437 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_object_set ((GObject*) _tmp25_, "markup", _tmp26_, NULL);
#line 402 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_free0 (detail);
#line 402 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_free0 (markup);
#line 2099 "tracker-view.c"
}


TrackerViewDisplay tracker_view_get_display (TrackerView* self) {
	TrackerViewDisplay result;
	TrackerViewDisplay _tmp0_;
#line 31 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 31 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = self->priv->_display;
#line 31 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	result = _tmp0_;
#line 31 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	return result;
#line 2114 "tracker-view.c"
}


static void tracker_view_set_display (TrackerView* self, TrackerViewDisplay value) {
	TrackerViewDisplay _tmp0_;
#line 32 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (self != NULL);
#line 32 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = value;
#line 32 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	self->priv->_display = _tmp0_;
#line 32 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_object_notify ((GObject *) self, "display");
#line 2128 "tracker-view.c"
}


TrackerResultStore* tracker_view_get_store (TrackerView* self) {
	TrackerResultStore* result;
	TrackerResultStore* _tmp0_;
#line 37 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = self->priv->_store;
#line 38 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	result = _tmp0_;
#line 38 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	return result;
#line 2143 "tracker-view.c"
}


void tracker_view_set_store (TrackerView* self, TrackerResultStore* value) {
	TrackerResultStore* _tmp0_;
	TrackerResultStore* _tmp3_;
	TrackerResultStore* _tmp4_;
	TrackerResultStore* _tmp5_;
	TrackerViewDisplay _tmp8_;
#line 40 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_return_if_fail (self != NULL);
#line 41 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp0_ = self->priv->_store;
#line 41 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp0_ != NULL) {
#line 2159 "tracker-view.c"
		TrackerResultStore* _tmp1_;
		guint _tmp2_ = 0U;
#line 42 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp1_ = self->priv->_store;
#line 42 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_signal_parse_name ("row-changed", GTK_TYPE_TREE_MODEL, &_tmp2_, NULL, FALSE);
#line 42 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_signal_handlers_disconnect_matched ((GtkTreeModel*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _tracker_view_store_row_changed_gtk_tree_model_row_changed, self);
#line 2168 "tracker-view.c"
	}
#line 45 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp3_ = value;
#line 45 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 45 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_object_unref0 (self->priv->_store);
#line 45 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	self->priv->_store = _tmp4_;
#line 47 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp5_ = self->priv->_store;
#line 47 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp5_ != NULL) {
#line 2182 "tracker-view.c"
		TrackerResultStore* _tmp6_;
		TrackerResultStore* _tmp7_;
#line 48 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp6_ = self->priv->_store;
#line 48 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_debug ("tracker-view.vala:48: using store:%p", _tmp6_);
#line 49 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp7_ = self->priv->_store;
#line 49 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_signal_connect_object ((GtkTreeModel*) _tmp7_, "row-changed", (GCallback) _tracker_view_store_row_changed_gtk_tree_model_row_changed, self, 0);
#line 2193 "tracker-view.c"
	}
#line 52 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_tmp8_ = self->priv->_display;
#line 52 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	if (_tmp8_ != TRACKER_VIEW_DISPLAY_FILE_ICONS) {
#line 2199 "tracker-view.c"
		GtkWidget* _tmp9_;
		TrackerResultStore* _tmp10_;
#line 53 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp9_ = self->priv->view;
#line 53 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp10_ = self->priv->_store;
#line 53 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		gtk_tree_view_set_model (GTK_TREE_VIEW (_tmp9_), (GtkTreeModel*) _tmp10_);
#line 2208 "tracker-view.c"
	} else {
		GtkWidget* _tmp11_;
		TrackerResultStore* _tmp12_;
#line 55 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp11_ = self->priv->view;
#line 55 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		_tmp12_ = self->priv->_store;
#line 55 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		gtk_icon_view_set_model (GTK_ICON_VIEW (_tmp11_), (GtkTreeModel*) _tmp12_);
#line 2218 "tracker-view.c"
	}
#line 40 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_object_notify ((GObject *) self, "store");
#line 2222 "tracker-view.c"
}


static void tracker_view_class_init (TrackerViewClass * klass) {
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	tracker_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_type_class_add_private (klass, sizeof (TrackerViewPrivate));
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	GTK_WIDGET_CLASS (klass)->unmap = tracker_view_real_unmap;
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tracker_view_get_property;
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tracker_view_set_property;
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	G_OBJECT_CLASS (klass)->finalize = tracker_view_finalize;
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRACKER_VIEW_DISPLAY, g_param_spec_enum ("display", "display", "display", TRACKER_VIEW_TYPE_DISPLAY, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRACKER_VIEW_STORE, g_param_spec_object ("store", "store", "store", TRACKER_TYPE_RESULT_STORE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2243 "tracker-view.c"
}


static void tracker_view_instance_init (TrackerView * self) {
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	self->priv = TRACKER_VIEW_GET_PRIVATE (self);
#line 60 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	self->priv->view = NULL;
#line 2252 "tracker-view.c"
}


static void tracker_view_finalize (GObject* obj) {
	TrackerView * self;
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	self = TRACKER_VIEW (obj);
#line 35 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_object_unref0 (self->priv->_store);
#line 60 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	_g_object_unref0 (self->priv->view);
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	G_OBJECT_CLASS (tracker_view_parent_class)->finalize (obj);
#line 2266 "tracker-view.c"
}


GType tracker_view_get_type (void) {
	static volatile gsize tracker_view_type_id__volatile = 0;
	if (g_once_init_enter (&tracker_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TrackerViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tracker_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrackerView), 0, (GInstanceInitFunc) tracker_view_instance_init, NULL };
		GType tracker_view_type_id;
		tracker_view_type_id = g_type_register_static (GTK_TYPE_SCROLLED_WINDOW, "TrackerView", &g_define_type_info, 0);
		g_once_init_leave (&tracker_view_type_id__volatile, tracker_view_type_id);
	}
	return tracker_view_type_id__volatile;
}


static void _vala_tracker_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TrackerView * self;
	self = TRACKER_VIEW (object);
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	switch (property_id) {
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_DISPLAY:
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_value_set_enum (value, tracker_view_get_display (self));
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		break;
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_STORE:
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		g_value_set_object (value, tracker_view_get_store (self));
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		break;
#line 2299 "tracker-view.c"
		default:
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		break;
#line 2305 "tracker-view.c"
	}
}


static void _vala_tracker_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TrackerView * self;
	self = TRACKER_VIEW (object);
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
	switch (property_id) {
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_DISPLAY:
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		tracker_view_set_display (self, g_value_get_enum (value));
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		break;
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		case TRACKER_VIEW_STORE:
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		tracker_view_set_store (self, g_value_get_object (value));
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		break;
#line 2327 "tracker-view.c"
		default:
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "/home/martyn/Source/tracker/src/tracker-needle/tracker-view.vala"
		break;
#line 2333 "tracker-view.c"
	}
}



